Revision bump for the 2.10.1 release
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 # Enable colors in shelltest
24 SHELLTESTARGS = "-c"
25
26 ACLOCAL_AMFLAGS = -I autotools
27 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
28 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
29 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
30 CHECK_HEADER = $(top_srcdir)/autotools/check-header
31 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
32 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
33 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
34 CHECK_VERSION = $(top_srcdir)/autotools/check-version
35 CHECK_NEWS = $(top_srcdir)/autotools/check-news
36 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
37 DOCPP = $(top_srcdir)/autotools/docpp
38 REPLACE_VARS_SED = autotools/replace_vars.sed
39 PRINT_PY_CONSTANTS = $(top_srcdir)/autotools/print-py-constants
40 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
41 SHELL_ENV_INIT = autotools/shell-env-init
42
43 # starting as of Ganeti 2.10, all files are stored in two directories,
44 # with only symbolic links added at other places.
45 #
46 # $(versiondir) contains most of Ganeti and all architecture-dependent files
47 # $(versionedsharedir) contains only architecture-independent files; all python
48 # executables need to go directly to $(versionedsharedir), as all ganeti python
49 # mdules are installed outside the usual python path, i.e., as private modules.
50 #
51 # $(defaultversiondir) and $(defaultversionedsharedir) are the corresponding
52 # directories for "the currently running" version of Ganeti. We never install
53 # there, but all symbolic links go there, rather than directory to $(versiondir)
54 # or $(versionedsharedir). Note that all links to $(default*dir) need to be stable;
55 # so, if some currently architecture-independent executable is replaced by an
56 # architecture-dependent one (and hence has to go under $(versiondir)), add a link
57 # under $(versionedsharedir) but do not change the external links.
58 if USE_VERSION_FULL
59 DIRVERSION=$(VERSION_FULL)
60 else
61 DIRVERSION=$(VERSION_MAJOR).$(VERSION_MINOR)
62 endif
63 versiondir = $(libdir)/ganeti/$(DIRVERSION)
64 defaultversiondir = $(libdir)/ganeti/default
65 versionedsharedir = $(prefix)/share/ganeti/$(DIRVERSION)
66 defaultversionedsharedir = $(prefix)/share/ganeti/default
67
68 # Note: these are automake-specific variables, and must be named after
69 # the directory + 'dir' suffix
70 pkglibdir = $(versiondir)$(libdir)/ganeti
71 myexeclibdir = $(pkglibdir)
72 bindir = $(versiondir)/$(BINDIR)
73 sbindir = $(versiondir)$(SBINDIR)
74 mandir = $(versionedsharedir)/root$(MANDIR)
75 pkgpythondir = $(versionedsharedir)/ganeti
76 gntpythondir = $(versionedsharedir)
77 pkgpython_bindir = $(versionedsharedir)
78 gnt_python_sbindir = $(versionedsharedir)
79 tools_pythondir = $(versionedsharedir)
80
81 clientdir = $(pkgpythondir)/client
82 cmdlibdir = $(pkgpythondir)/cmdlib
83 hypervisordir = $(pkgpythondir)/hypervisor
84 storagedir = $(pkgpythondir)/storage
85 httpdir = $(pkgpythondir)/http
86 masterddir = $(pkgpythondir)/masterd
87 confddir = $(pkgpythondir)/confd
88 rapidir = $(pkgpythondir)/rapi
89 serverdir = $(pkgpythondir)/server
90 watcherdir = $(pkgpythondir)/watcher
91 impexpddir = $(pkgpythondir)/impexpd
92 utilsdir = $(pkgpythondir)/utils
93 toolsdir = $(pkglibdir)/tools
94 iallocatorsdir = $(pkglibdir)/iallocators
95 pytoolsdir = $(pkgpythondir)/tools
96 docdir = $(versiondir)$(datadir)/doc/$(PACKAGE)
97
98 SYMLINK_TARGET_DIRS = \
99         $(sysconfdir)/ganeti \
100         $(libdir)/ganeti/iallocators \
101         $(libdir)/ganeti/tools \
102         $(prefix)/share/ganeti \
103         $(BINDIR) \
104         $(SBINDIR) \
105         $(MANDIR)/man1 \
106         $(MANDIR)/man7 \
107         $(MANDIR)/man8
108
109 # Delete output file if an error occurred while building it
110 .DELETE_ON_ERROR:
111
112 HS_DIRS = \
113         src \
114         src/Ganeti \
115         src/Ganeti/Confd \
116         src/Ganeti/Curl \
117         src/Ganeti/Cpu \
118         src/Ganeti/DataCollectors \
119         src/Ganeti/Hs2Py \
120         src/Ganeti/HTools \
121         src/Ganeti/HTools/Backend \
122         src/Ganeti/HTools/Program \
123         src/Ganeti/Hypervisor \
124         src/Ganeti/Hypervisor/Xen \
125         src/Ganeti/Monitoring \
126         src/Ganeti/Query \
127         src/Ganeti/Storage \
128         src/Ganeti/Storage/Diskstats \
129         src/Ganeti/Storage/Drbd \
130         src/Ganeti/Storage/Lvm \
131         test/hs \
132         test/hs/Test \
133         test/hs/Test/Ganeti \
134         test/hs/Test/Ganeti/Storage \
135         test/hs/Test/Ganeti/Storage/Diskstats \
136         test/hs/Test/Ganeti/Storage/Drbd \
137         test/hs/Test/Ganeti/Storage/Lvm \
138         test/hs/Test/Ganeti/Confd \
139         test/hs/Test/Ganeti/HTools \
140         test/hs/Test/Ganeti/HTools/Backend \
141         test/hs/Test/Ganeti/Hypervisor \
142         test/hs/Test/Ganeti/Hypervisor/Xen \
143         test/hs/Test/Ganeti/Query
144
145 # Haskell directories without the roots (src, test/hs)
146 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
147
148 DIRS = \
149         $(HS_DIRS) \
150         autotools \
151         daemons \
152         devel \
153         devel/data \
154         doc \
155         doc/css \
156         doc/examples \
157         doc/examples/gnt-debug \
158         doc/examples/hooks \
159         doc/users \
160         test/data/htools \
161         test/data/htools/rapi \
162         test/hs/shelltests \
163         test/autotools \
164         lib \
165         lib/build \
166         lib/client \
167         lib/cmdlib \
168         lib/confd \
169         lib/http \
170         lib/hypervisor \
171         lib/impexpd \
172         lib/masterd \
173         lib/rapi \
174         lib/server \
175         lib/storage \
176         lib/tools \
177         lib/utils \
178         lib/watcher \
179         man \
180         qa \
181         test \
182         test/data \
183         test/data/bdev-rbd \
184         test/data/ovfdata \
185         test/data/ovfdata/other \
186         test/py \
187         test/py/cmdlib \
188         test/py/cmdlib/testsupport \
189         tools
190
191 ALL_APIDOC_HS_DIRS = \
192         $(APIDOC_HS_DIR) \
193         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
194
195 BUILDTIME_DIR_AUTOCREATE = \
196         scripts \
197         $(APIDOC_DIR) \
198         $(ALL_APIDOC_HS_DIRS) \
199         $(APIDOC_PY_DIR) \
200         $(COVERAGE_DIR) \
201         $(COVERAGE_HS_DIR) \
202         $(COVERAGE_PY_DIR) \
203         .hpc
204
205 BUILDTIME_DIRS = \
206         $(BUILDTIME_DIR_AUTOCREATE) \
207         doc/html \
208         doc/man-html
209
210 DIRCHECK_EXCLUDE = \
211         $(BUILDTIME_DIRS) \
212         ganeti-[0-9]*.[0-9]*.[0-9]* \
213         doc/html/_* \
214         doc/man-html/_* \
215         autom4te.cache
216
217 # some helper vars
218 COVERAGE_DIR = doc/coverage
219 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
220 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
221 APIDOC_DIR = doc/api
222 APIDOC_PY_DIR = $(APIDOC_DIR)/py
223 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
224
225 MAINTAINERCLEANFILES = \
226         $(maninput) \
227         doc/install-quick.rst \
228         doc/news.rst \
229         doc/upgrade.rst \
230         vcs-version
231
232 maintainer-clean-local:
233         rm -rf $(BUILDTIME_DIRS)
234
235 CLEANFILES = \
236         $(addsuffix /*.py[co],$(DIRS)) \
237         $(addsuffix /*.hi,$(HS_DIRS)) \
238         $(addsuffix /*.o,$(HS_DIRS)) \
239         $(PYTHON_BOOTSTRAP) \
240         $(gnt_python_sbin_SCRIPTS) \
241         epydoc.conf \
242         $(REPLACE_VARS_SED) \
243         $(SHELL_ENV_INIT) \
244         daemons/daemon-util \
245         daemons/ganeti-cleaner \
246         devel/squeeze-amd64.tar.gz \
247         devel/squeeze-amd64.conf \
248         $(mandocrst) \
249         doc/manpages-enabled.rst \
250         $(BUILT_EXAMPLES) \
251         doc/examples/bash_completion \
252         doc/examples/bash_completion-debug \
253         $(userspecs) \
254         lib/_generated_rpc.py \
255         $(man_MANS) \
256         $(manhtml) \
257         tools/kvm-ifup \
258         tools/vif-ganeti \
259         tools/net-common \
260         tools/users-setup \
261         tools/vcluster-setup \
262         stamp-directories \
263         stamp-srclinks \
264         $(nodist_pkgpython_PYTHON) \
265         $(gnt_scripts) \
266         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
267         $(HS_BUILT_TEST_HELPERS) \
268         src/ganeti-confd \
269         src/ganeti-luxid \
270         src/ganeti-mond \
271         .hpc/*.mix src/*.tix test/hs/*.tix *.tix \
272         doc/hs-lint.html
273
274 GENERATED_FILES = \
275         $(built_base_sources) \
276         $(BUILT_PYTHON_SOURCES) \
277         $(PYTHON_BOOTSTRAP) \
278         $(gnt_python_sbin_SCRIPTS)
279
280 HS_GENERATED_FILES =
281 if WANT_HTOOLS
282 HS_GENERATED_FILES += $(HS_PROGS)
283 if ENABLE_CONFD
284 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
285 endif
286
287 if ENABLE_MOND
288 HS_GENERATED_FILES += src/ganeti-mond
289 endif
290 endif
291
292 built_base_sources = \
293         stamp-directories \
294         stamp-srclinks
295
296 built_python_base_sources = \
297         lib/_constants.py \
298         lib/_vcsversion.py \
299         lib/opcodes.py
300
301 BUILT_PYTHON_SOURCES = \
302         $(built_python_base_sources) \
303         lib/_generated_rpc.py
304
305 # Generating the RPC wrappers depends on many things, so make sure
306 # it's built at the end of the built sources
307 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
308
309 # these are all built from the underlying %.in sources
310 BUILT_EXAMPLES = \
311         doc/examples/ganeti-kvm-poweroff.initd \
312         doc/examples/ganeti.cron \
313         doc/examples/ganeti.initd \
314         doc/examples/ganeti.logrotate \
315         doc/examples/ganeti-master-role.ocf \
316         doc/examples/ganeti-node-role.ocf \
317         doc/examples/gnt-config-backup \
318         doc/examples/hooks/ipsec
319
320 nodist_pkgpython_PYTHON = \
321         $(BUILT_PYTHON_SOURCES)
322
323 nodist_pkgpython_bin_SCRIPTS = \
324         $(nodist_pkglib_python_scripts)
325
326 pkgpython_bin_SCRIPTS = \
327         $(pkglib_python_scripts)
328
329 noinst_PYTHON = \
330         lib/build/__init__.py \
331         lib/build/shell_example_lexer.py \
332         lib/build/sphinx_ext.py
333
334 pkgpython_PYTHON = \
335         lib/__init__.py \
336         lib/asyncnotifier.py \
337         lib/backend.py \
338         lib/bootstrap.py \
339         lib/cli.py \
340         lib/compat.py \
341         lib/config.py \
342         lib/constants.py \
343         lib/daemon.py \
344         lib/errors.py \
345         lib/hooksmaster.py \
346         lib/ht.py \
347         lib/jqueue.py \
348         lib/jstore.py \
349         lib/locking.py \
350         lib/luxi.py \
351         lib/mcpu.py \
352         lib/netutils.py \
353         lib/objects.py \
354         lib/opcodes_base.py \
355         lib/outils.py \
356         lib/ovf.py \
357         lib/pathutils.py \
358         lib/qlang.py \
359         lib/query.py \
360         lib/rpc.py \
361         lib/rpc_defs.py \
362         lib/runtime.py \
363         lib/serializer.py \
364         lib/ssconf.py \
365         lib/ssh.py \
366         lib/uidpool.py \
367         lib/vcluster.py \
368         lib/network.py \
369         lib/workerpool.py
370
371 client_PYTHON = \
372         lib/client/__init__.py \
373         lib/client/gnt_backup.py \
374         lib/client/gnt_cluster.py \
375         lib/client/gnt_debug.py \
376         lib/client/gnt_group.py \
377         lib/client/gnt_instance.py \
378         lib/client/gnt_job.py \
379         lib/client/gnt_node.py \
380         lib/client/gnt_network.py \
381         lib/client/gnt_os.py \
382         lib/client/gnt_storage.py
383
384 cmdlib_PYTHON = \
385         lib/cmdlib/__init__.py \
386         lib/cmdlib/backup.py \
387         lib/cmdlib/base.py \
388         lib/cmdlib/cluster.py \
389         lib/cmdlib/common.py \
390         lib/cmdlib/group.py \
391         lib/cmdlib/instance.py \
392         lib/cmdlib/instance_migration.py \
393         lib/cmdlib/instance_operation.py \
394         lib/cmdlib/instance_query.py \
395         lib/cmdlib/instance_storage.py \
396         lib/cmdlib/instance_utils.py \
397         lib/cmdlib/misc.py \
398         lib/cmdlib/network.py \
399         lib/cmdlib/node.py \
400         lib/cmdlib/operating_system.py \
401         lib/cmdlib/query.py \
402         lib/cmdlib/tags.py \
403         lib/cmdlib/test.py
404
405 hypervisor_PYTHON = \
406         lib/hypervisor/__init__.py \
407         lib/hypervisor/hv_base.py \
408         lib/hypervisor/hv_chroot.py \
409         lib/hypervisor/hv_fake.py \
410         lib/hypervisor/hv_kvm.py \
411         lib/hypervisor/hv_lxc.py \
412         lib/hypervisor/hv_xen.py
413
414 storage_PYTHON = \
415         lib/storage/__init__.py \
416         lib/storage/bdev.py \
417         lib/storage/base.py \
418         lib/storage/container.py \
419         lib/storage/drbd.py \
420         lib/storage/drbd_info.py \
421         lib/storage/drbd_cmdgen.py \
422         lib/storage/filestorage.py
423
424 rapi_PYTHON = \
425         lib/rapi/__init__.py \
426         lib/rapi/baserlib.py \
427         lib/rapi/client.py \
428         lib/rapi/client_utils.py \
429         lib/rapi/connector.py \
430         lib/rapi/rlib2.py \
431         lib/rapi/testutils.py
432
433 http_PYTHON = \
434         lib/http/__init__.py \
435         lib/http/auth.py \
436         lib/http/client.py \
437         lib/http/server.py
438
439 confd_PYTHON = \
440         lib/confd/__init__.py \
441         lib/confd/client.py
442
443 masterd_PYTHON = \
444         lib/masterd/__init__.py \
445         lib/masterd/iallocator.py \
446         lib/masterd/instance.py
447
448 impexpd_PYTHON = \
449         lib/impexpd/__init__.py
450
451 watcher_PYTHON = \
452         lib/watcher/__init__.py \
453         lib/watcher/nodemaint.py \
454         lib/watcher/state.py
455
456 server_PYTHON = \
457         lib/server/__init__.py \
458         lib/server/masterd.py \
459         lib/server/noded.py \
460         lib/server/rapi.py
461
462 pytools_PYTHON = \
463         lib/tools/__init__.py \
464         lib/tools/burnin.py \
465         lib/tools/ensure_dirs.py \
466         lib/tools/node_cleanup.py \
467         lib/tools/node_daemon_setup.py \
468         lib/tools/prepare_node_join.py
469
470 utils_PYTHON = \
471         lib/utils/__init__.py \
472         lib/utils/algo.py \
473         lib/utils/filelock.py \
474         lib/utils/hash.py \
475         lib/utils/io.py \
476         lib/utils/log.py \
477         lib/utils/lvm.py \
478         lib/utils/mlock.py \
479         lib/utils/nodesetup.py \
480         lib/utils/process.py \
481         lib/utils/retry.py \
482         lib/utils/storage.py \
483         lib/utils/text.py \
484         lib/utils/version.py \
485         lib/utils/wrapper.py \
486         lib/utils/x509.py
487
488 docinput = \
489         doc/admin.rst \
490         doc/cluster-keys-replacement.rst \
491         doc/cluster-merge.rst \
492         doc/conf.py \
493         doc/css/style.css \
494         doc/design-2.0.rst \
495         doc/design-2.1.rst \
496         doc/design-2.2.rst \
497         doc/design-2.3.rst \
498         doc/design-2.4.rst \
499         doc/design-2.5.rst \
500         doc/design-2.6.rst \
501         doc/design-2.7.rst \
502         doc/design-2.8.rst \
503         doc/design-2.9.rst \
504         doc/design-2.10.rst \
505         doc/design-autorepair.rst \
506         doc/design-bulk-create.rst \
507         doc/design-ceph-ganeti-support.rst \
508         doc/design-chained-jobs.rst \
509         doc/design-cmdlib-unittests.rst \
510         doc/design-cpu-pinning.rst \
511         doc/design-daemons.rst \
512         doc/design-device-uuid-name.rst \
513         doc/design-draft.rst \
514         doc/design-file-based-storage.rst \
515         doc/design-glusterfs-ganeti-support.rst \
516         doc/design-hotplug.rst \
517         doc/design-hroller.rst \
518         doc/design-hsqueeze.rst \
519         doc/design-htools-2.3.rst \
520         doc/design-http-server.rst \
521         doc/design-hugepages-support.rst \
522         doc/design-impexp2.rst \
523         doc/design-internal-shutdown.rst \
524         doc/design-linuxha.rst \
525         doc/design-lu-generated-jobs.rst \
526         doc/design-monitoring-agent.rst \
527         doc/design-multi-reloc.rst \
528         doc/design-network.rst \
529         doc/design-node-add.rst \
530         doc/design-oob.rst \
531         doc/design-openvswitch.rst \
532         doc/design-opportunistic-locking.rst \
533         doc/design-optables.rst \
534         doc/design-ovf-support.rst \
535         doc/design-partitioned.rst \
536         doc/design-query-splitting.rst \
537         doc/design-query2.rst \
538         doc/design-reason-trail.rst \
539         doc/design-resource-model.rst \
540         doc/design-restricted-commands.rst \
541         doc/design-shared-storage.rst \
542         doc/design-storagetypes.rst \
543         doc/design-upgrade.rst \
544         doc/design-virtual-clusters.rst \
545         doc/design-x509-ca.rst \
546         doc/dev-codestyle.rst \
547         doc/devnotes.rst \
548         doc/glossary.rst \
549         doc/hooks.rst \
550         doc/iallocator.rst \
551         doc/index.rst \
552         doc/install-quick.rst \
553         doc/install.rst \
554         doc/locking.rst \
555         doc/manpages-disabled.rst \
556         doc/monitoring-query-format.rst \
557         doc/move-instance.rst \
558         doc/news.rst \
559         doc/ovfconverter.rst \
560         doc/rapi.rst \
561         doc/security.rst \
562         doc/upgrade.rst \
563         doc/virtual-cluster.rst \
564         doc/walkthrough.rst
565
566 # Generates file names such as "doc/man-gnt-instance.rst"
567 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
568
569 # Haskell programs to be installed in $PREFIX/bin
570 HS_BIN_PROGS=src/htools
571
572 # Haskell programs to be installed in the MYEXECLIB dir
573 if ENABLE_MOND
574 HS_MYEXECLIB_PROGS=src/mon-collector
575 else
576 HS_MYEXECLIB_PROGS=
577 endif
578
579 # Haskell programs to be compiled by "make really-all"
580 HS_COMPILE_PROGS= \
581         src/ganeti-mond \
582         src/hconfd \
583         src/hluxid \
584         src/hs2py \
585         src/rpc-test
586
587 # All Haskell non-test programs to be compiled but not automatically installed
588 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
589
590 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
591 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
592
593 # Haskell programs that cannot be disabled at configure (e.g., unlike
594 # 'mon-collector')
595 HS_DEFAULT_PROGS = \
596         $(HS_BIN_PROGS) \
597         test/hs/hpc-htools \
598         test/hs/hpc-mon-collector \
599         test/hs/htest \
600         $(HS_COMPILE_PROGS)
601
602 HS_ALL_PROGS = $(HS_DEFAULT_PROGS) $(HS_MYEXECLIB_PROGS)
603
604 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_DEFAULT_PROGS)) src/mon-collector.hs
605 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
606
607 HFLAGS = \
608         -O -Wall -Werror -isrc \
609         -fwarn-monomorphism-restriction \
610         -fwarn-tabs \
611         $(GHC_BYVERSION_FLAGS)
612
613 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
614 HEXTRA =
615 # internal extra flags (used for test/hs/htest mainly)
616 HEXTRA_INT =
617 # exclude options for coverage reports
618 HPCEXCL = --exclude Main \
619         --exclude Ganeti.Constants \
620         --exclude Ganeti.HTools.QC \
621         --exclude Ganeti.THH \
622         --exclude Ganeti.Version \
623         --exclude Test.Ganeti.Attoparsec \
624         --exclude Test.Ganeti.TestCommon \
625         --exclude Test.Ganeti.TestHTools \
626         --exclude Test.Ganeti.TestHelper \
627         --exclude Test.Ganeti.TestImports \
628         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
629
630 HS_LIB_SRCS = \
631         src/Ganeti/BasicTypes.hs \
632         src/Ganeti/Common.hs \
633         src/Ganeti/Compat.hs \
634         src/Ganeti/Confd/Client.hs \
635         src/Ganeti/Confd/ClientFunctions.hs \
636         src/Ganeti/Confd/Server.hs \
637         src/Ganeti/Confd/Types.hs \
638         src/Ganeti/Confd/Utils.hs \
639         src/Ganeti/Config.hs \
640         src/Ganeti/ConfigReader.hs \
641         src/Ganeti/Constants.hs \
642         src/Ganeti/ConstantUtils.hs \
643         src/Ganeti/Cpu/LoadParser.hs \
644         src/Ganeti/Cpu/Types.hs \
645         src/Ganeti/Curl/Multi.hs \
646         src/Ganeti/Daemon.hs \
647         src/Ganeti/DataCollectors/CLI.hs \
648         src/Ganeti/DataCollectors/CPUload.hs \
649         src/Ganeti/DataCollectors/Diskstats.hs \
650         src/Ganeti/DataCollectors/Drbd.hs \
651         src/Ganeti/DataCollectors/InstStatus.hs \
652         src/Ganeti/DataCollectors/InstStatusTypes.hs \
653         src/Ganeti/DataCollectors/Lv.hs \
654         src/Ganeti/DataCollectors/Program.hs \
655         src/Ganeti/DataCollectors/Types.hs \
656         src/Ganeti/Errors.hs \
657         src/Ganeti/HTools/Backend/IAlloc.hs \
658         src/Ganeti/HTools/Backend/Luxi.hs \
659         src/Ganeti/HTools/Backend/Rapi.hs \
660         src/Ganeti/HTools/Backend/Simu.hs \
661         src/Ganeti/HTools/Backend/Text.hs \
662         src/Ganeti/HTools/CLI.hs \
663         src/Ganeti/HTools/Cluster.hs \
664         src/Ganeti/HTools/Container.hs \
665         src/Ganeti/HTools/ExtLoader.hs \
666         src/Ganeti/HTools/Graph.hs \
667         src/Ganeti/HTools/Group.hs \
668         src/Ganeti/HTools/Instance.hs \
669         src/Ganeti/HTools/Loader.hs \
670         src/Ganeti/HTools/Nic.hs \
671         src/Ganeti/HTools/Node.hs \
672         src/Ganeti/HTools/PeerMap.hs \
673         src/Ganeti/HTools/Program/Hail.hs \
674         src/Ganeti/HTools/Program/Harep.hs \
675         src/Ganeti/HTools/Program/Hbal.hs \
676         src/Ganeti/HTools/Program/Hcheck.hs \
677         src/Ganeti/HTools/Program/Hinfo.hs \
678         src/Ganeti/HTools/Program/Hscan.hs \
679         src/Ganeti/HTools/Program/Hspace.hs \
680         src/Ganeti/HTools/Program/Hroller.hs \
681         src/Ganeti/HTools/Program/Main.hs \
682         src/Ganeti/HTools/Types.hs \
683         src/Ganeti/Hypervisor/Xen.hs \
684         src/Ganeti/Hypervisor/Xen/XmParser.hs \
685         src/Ganeti/Hypervisor/Xen/Types.hs \
686         src/Ganeti/Hash.hs \
687         src/Ganeti/Hs2Py/GenConstants.hs \
688         src/Ganeti/Hs2Py/GenOpCodes.hs \
689         src/Ganeti/Hs2Py/OpDoc.hs \
690         src/Ganeti/JQueue.hs \
691         src/Ganeti/JSON.hs \
692         src/Ganeti/Jobs.hs \
693         src/Ganeti/Logging.hs \
694         src/Ganeti/Luxi.hs \
695         src/Ganeti/Monitoring/Server.hs \
696         src/Ganeti/Network.hs \
697         src/Ganeti/Objects.hs \
698         src/Ganeti/OpCodes.hs \
699         src/Ganeti/OpParams.hs \
700         src/Ganeti/Path.hs \
701         src/Ganeti/Parsers.hs \
702         src/Ganeti/PyValueInstances.hs \
703         src/Ganeti/Query/Cluster.hs \
704         src/Ganeti/Query/Common.hs \
705         src/Ganeti/Query/Export.hs \
706         src/Ganeti/Query/Filter.hs \
707         src/Ganeti/Query/Group.hs \
708         src/Ganeti/Query/Job.hs \
709         src/Ganeti/Query/Language.hs \
710         src/Ganeti/Query/Network.hs \
711         src/Ganeti/Query/Node.hs \
712         src/Ganeti/Query/Query.hs \
713         src/Ganeti/Query/Server.hs \
714         src/Ganeti/Query/Types.hs \
715         src/Ganeti/Rpc.hs \
716         src/Ganeti/Runtime.hs \
717         src/Ganeti/Ssconf.hs \
718         src/Ganeti/Storage/Diskstats/Parser.hs \
719         src/Ganeti/Storage/Diskstats/Types.hs \
720         src/Ganeti/Storage/Drbd/Parser.hs \
721         src/Ganeti/Storage/Drbd/Types.hs \
722         src/Ganeti/Storage/Lvm/LVParser.hs \
723         src/Ganeti/Storage/Lvm/Types.hs \
724         src/Ganeti/Storage/Utils.hs \
725         src/Ganeti/THH.hs \
726         src/Ganeti/Types.hs \
727         src/Ganeti/Utils.hs
728
729 HS_TEST_SRCS = \
730         test/hs/Test/AutoConf.hs \
731         test/hs/Test/Ganeti/Attoparsec.hs \
732         test/hs/Test/Ganeti/BasicTypes.hs \
733         test/hs/Test/Ganeti/Common.hs \
734         test/hs/Test/Ganeti/Confd/Types.hs \
735         test/hs/Test/Ganeti/Confd/Utils.hs \
736         test/hs/Test/Ganeti/Constants.hs \
737         test/hs/Test/Ganeti/Daemon.hs \
738         test/hs/Test/Ganeti/Errors.hs \
739         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
740         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
741         test/hs/Test/Ganeti/HTools/CLI.hs \
742         test/hs/Test/Ganeti/HTools/Cluster.hs \
743         test/hs/Test/Ganeti/HTools/Container.hs \
744         test/hs/Test/Ganeti/HTools/ExtLoader.hs \
745         test/hs/Test/Ganeti/HTools/Graph.hs \
746         test/hs/Test/Ganeti/HTools/Instance.hs \
747         test/hs/Test/Ganeti/HTools/Loader.hs \
748         test/hs/Test/Ganeti/HTools/Node.hs \
749         test/hs/Test/Ganeti/HTools/PeerMap.hs \
750         test/hs/Test/Ganeti/HTools/Types.hs \
751         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
752         test/hs/Test/Ganeti/JSON.hs \
753         test/hs/Test/Ganeti/Jobs.hs \
754         test/hs/Test/Ganeti/JQueue.hs \
755         test/hs/Test/Ganeti/Luxi.hs \
756         test/hs/Test/Ganeti/Network.hs \
757         test/hs/Test/Ganeti/Objects.hs \
758         test/hs/Test/Ganeti/OpCodes.hs \
759         test/hs/Test/Ganeti/Query/Filter.hs \
760         test/hs/Test/Ganeti/Query/Language.hs \
761         test/hs/Test/Ganeti/Query/Network.hs \
762         test/hs/Test/Ganeti/Query/Query.hs \
763         test/hs/Test/Ganeti/Rpc.hs \
764         test/hs/Test/Ganeti/Runtime.hs \
765         test/hs/Test/Ganeti/Ssconf.hs \
766         test/hs/Test/Ganeti/Storage/Diskstats/Parser.hs \
767         test/hs/Test/Ganeti/Storage/Drbd/Parser.hs \
768         test/hs/Test/Ganeti/Storage/Drbd/Types.hs \
769         test/hs/Test/Ganeti/Storage/Lvm/LVParser.hs \
770         test/hs/Test/Ganeti/THH.hs \
771         test/hs/Test/Ganeti/TestCommon.hs \
772         test/hs/Test/Ganeti/TestHTools.hs \
773         test/hs/Test/Ganeti/TestHelper.hs \
774         test/hs/Test/Ganeti/Types.hs \
775         test/hs/Test/Ganeti/Utils.hs
776
777 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
778
779 HS_BUILT_SRCS = \
780         test/hs/Test/Ganeti/TestImports.hs \
781         src/AutoConf.hs \
782         src/Ganeti/Hs2Py/ListConstants.hs \
783         src/Ganeti/Curl/Internal.hs \
784         src/Ganeti/Version.hs
785 HS_BUILT_SRCS_IN = \
786         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
787         src/Ganeti/Curl/Internal.hsc \
788         lib/_constants.py.in \
789         lib/opcodes.py.in_after \
790         lib/opcodes.py.in_before
791
792 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
793
794 $(RUN_IN_TEMPDIR): | stamp-directories
795
796 doc/html/index.html: ENABLE_MANPAGES =
797 doc/man-html/index.html: ENABLE_MANPAGES = 1
798 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
799
800 # Note: we use here an order-only prerequisite, as the contents of
801 # _constants.py are not actually influencing the html build output: it
802 # has to exist in order for the sphinx module to be loaded
803 # successfully, but we certainly don't want the docs to be rebuilt if
804 # it changes
805 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
806         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
807         lib/build/shell_example_lexer.py lib/ht.py \
808         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
809         autotools/sphinx-wrapper | $(BUILT_PYTHON_SOURCES)
810         @test -n "$(SPHINX)" || \
811             { echo 'sphinx-build' not found during configure; exit 1; }
812 if !MANPAGES_IN_DOC
813         if test -n '$(ENABLE_MANPAGES)'; then \
814           echo 'Man pages in documentation were disabled at configure time' >&2; \
815           exit 1; \
816         fi
817 endif
818 ## Sphinx provides little control over what content should be included. Some
819 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
820 ## build two different versions of the documentation--once without man pages and
821 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
822 ## us with this, but requires running in a temporary directory. It moves the
823 ## correct files into place depending on environment variables.
824         dir=$(dir $@) && \
825         @mkdir_p@ $$dir && \
826         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
827         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
828             -d . \
829             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
830             -D release="$(PACKAGE_VERSION)" \
831             -D graphviz_dot="$(DOT)" \
832             -D enable_manpages="$(ENABLE_MANPAGES)" \
833             doc $(CURDIR)/$$dir && \
834         rm -f $$dir/.buildinfo $$dir/objects.inv
835         touch $@
836
837 doc/html: doc/html/index.html
838
839 doc/man-html: doc/man-html/index.html
840
841 doc/install-quick.rst: INSTALL
842 doc/news.rst: NEWS
843 doc/upgrade.rst: UPGRADE
844
845 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
846         set -e; \
847         { echo '.. This file is automatically updated at build time from $<.'; \
848           echo '.. Do not edit.'; \
849           echo; \
850           cat $<; \
851         } > $@
852
853 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
854         { echo '.. This file is automatically generated, do not edit!'; \
855           echo ''; \
856           echo 'Man pages'; \
857           echo '========='; \
858           echo; \
859           echo '.. toctree::'; \
860           echo '   :maxdepth: 1'; \
861           echo; \
862           for i in $(notdir $(mandocrst)); do \
863             echo "   $$i"; \
864           done | LC_ALL=C sort; \
865         } > $@
866
867 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
868 if MANPAGES_IN_DOC
869         { echo '.. This file is automatically updated at build time from $<.'; \
870           echo '.. Do not edit.'; \
871           echo; \
872           echo "$*"; \
873           echo '=========================================='; \
874           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
875         } > $@
876 else
877         echo 'Man pages in documentation were disabled at configure time' >&2; \
878         exit 1;
879 endif
880
881 doc/users/%: doc/users/%.in Makefile $(REPLACE_VARS_SED)
882         cat $< | sed -f $(REPLACE_VARS_SED) | LC_ALL=C sort | uniq | (grep -v '^root' || true) > $@
883
884 userspecs = \
885         doc/users/users \
886         doc/users/groups \
887         doc/users/groupmemberships
888
889 # Things to build but not to install (add it to EXTRA_DIST if it should be
890 # distributed)
891 noinst_DATA = \
892         $(BUILT_EXAMPLES) \
893         doc/examples/bash_completion \
894         doc/examples/bash_completion-debug \
895         $(userspecs) \
896         $(manhtml)
897
898 if HAS_SPHINX
899 if MANPAGES_IN_DOC
900 noinst_DATA += doc/man-html
901 else
902 noinst_DATA += doc/html
903 endif
904 endif
905
906 gnt_scripts = \
907         scripts/gnt-backup \
908         scripts/gnt-cluster \
909         scripts/gnt-debug \
910         scripts/gnt-group \
911         scripts/gnt-instance \
912         scripts/gnt-job \
913         scripts/gnt-network \
914         scripts/gnt-node \
915         scripts/gnt-os \
916         scripts/gnt-storage
917
918 gnt_scripts_basenames = \
919         $(patsubst scripts/%,%,$(patsubst daemons/%,%,$(gnt_scripts) $(gnt_python_sbin_SCRIPTS)))
920
921 gnt_python_sbin_SCRIPTS = \
922         $(PYTHON_BOOTSTRAP_SBIN)
923
924 gntpython_SCRIPTS = $(gnt_scripts)
925
926 PYTHON_BOOTSTRAP_SBIN = \
927         daemons/ganeti-masterd \
928         daemons/ganeti-noded \
929         daemons/ganeti-rapi \
930         daemons/ganeti-watcher
931
932 PYTHON_BOOTSTRAP = \
933         tools/burnin \
934         tools/ensure-dirs \
935         tools/node-cleanup \
936         tools/node-daemon-setup \
937         tools/prepare-node-join
938
939 qa_scripts = \
940         qa/__init__.py \
941         qa/ganeti-qa.py \
942         qa/qa_cluster.py \
943         qa/qa_config.py \
944         qa/qa_daemon.py \
945         qa/qa_env.py \
946         qa/qa_error.py \
947         qa/qa_group.py \
948         qa/qa_instance.py \
949         qa/qa_instance_utils.py \
950         qa/qa_job.py \
951         qa/qa_monitoring.py \
952         qa/qa_node.py \
953         qa/qa_os.py \
954         qa/qa_rapi.py \
955         qa/qa_tags.py \
956         qa/qa_utils.py
957
958 bin_SCRIPTS =
959 if WANT_HTOOLS
960 bin_SCRIPTS += $(HS_BIN_PROGS)
961 install-exec-hook:
962         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
963 # FIXME: this is a hardcoded logic, instead of auto-resolving
964         $(LN_S) -f ../../../bin/htools \
965           $(DESTDIR)$(iallocatorsdir)/hail
966         for role in $(HS_BIN_ROLES); do \
967           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
968         done
969 endif
970
971 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
972         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
973           echo "Error: cannot run unittests without the development" \
974                " libraries (see devnotes.rst)" 1>&2; \
975           exit 1; \
976         fi
977         @rm -f $(notdir $@).tix
978         $(GHC) --make \
979           $(HFLAGS) \
980           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
981           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
982           $(HEXTRA) $(HEXTRA_INT) $@
983         @touch "$@"
984
985 # for the test/hs/htest binary, we need to enable profiling/coverage
986 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
987
988 # we compile the hpc-htools binary with the program coverage
989 test/hs/hpc-htools: HEXTRA_INT=-fhpc
990
991 # we compile the hpc-mon-collector binary with the program coverage
992 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
993
994 # test dependency
995 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
996
997 # rules for building profiling-enabled versions of the haskell
998 # programs: hs-prof does the full two-step build, whereas
999 # hs-prof-quick does only the final rebuild (hs-prof must have been
1000 # run before)
1001 .PHONY: hs-prof hs-prof-quick
1002 hs-prof:
1003         @if [ -z "$(TARGET)" ]; then \
1004           echo "You need to define TARGET when running this rule" 1>&2; \
1005           exit 1; \
1006         fi
1007         $(MAKE) $(AM_MAKEFLAGS) clean
1008         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
1009         rm -f $(HS_ALL_PROGS)
1010         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
1011
1012 hs-prof-quick:
1013         @if [ -z "$(TARGET)" ]; then \
1014           echo "You need to define TARGET when running this rule" 1>&2; \
1015           exit 1; \
1016         fi
1017         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
1018
1019 dist_sbin_SCRIPTS = \
1020         tools/ganeti-listrunner
1021
1022 nodist_sbin_SCRIPTS = \
1023         daemons/ganeti-cleaner
1024
1025 # strip path prefixes off the sbin scripts
1026 all_sbin_scripts = \
1027         $(patsubst tools/%,%,$(patsubst daemons/%,%,$(patsubst scripts/%,%,\
1028         $(patsubst src/%,%,$(dist_sbin_SCRIPTS) $(nodist_sbin_SCRIPTS)))))
1029
1030 if ENABLE_CONFD
1031 src/ganeti-confd: src/hconfd
1032         cp -f $< $@
1033
1034 src/ganeti-luxid: src/hluxid
1035         cp -f $< $@
1036
1037 nodist_sbin_SCRIPTS += src/ganeti-confd
1038 nodist_sbin_SCRIPTS += src/ganeti-luxid
1039 endif
1040
1041 if ENABLE_MOND
1042 nodist_sbin_SCRIPTS += src/ganeti-mond
1043 endif
1044
1045 python_scripts = \
1046         tools/cfgshell \
1047         tools/cfgupgrade \
1048         tools/cfgupgrade12 \
1049         tools/cluster-merge \
1050         tools/confd-client \
1051         tools/fmtjson \
1052         tools/lvmstrap \
1053         tools/move-instance \
1054         tools/ovfconverter \
1055         tools/post-upgrade \
1056         tools/sanitize-config
1057
1058 dist_tools_SCRIPTS = \
1059         tools/kvm-console-wrapper \
1060         tools/master-ip-setup \
1061         tools/xen-console-wrapper
1062
1063 dist_tools_python_SCRIPTS = \
1064         $(python_scripts) \
1065         tools/burnin
1066
1067 nodist_tools_python_SCRIPTS = \
1068         tools/node-cleanup
1069
1070 tools_python_basenames = $(patsubst tools/%,%,\
1071         $(dist_tools_python_SCRIPTS) $(nodist_tools_python_SCRIPTS))
1072
1073 nodist_tools_SCRIPTS = \
1074         tools/users-setup \
1075         tools/vcluster-setup
1076
1077 tools_basenames = $(patsubst tools/%,%,$(nodist_tools_SCRIPTS) $(dist_tools_SCRIPTS))
1078
1079 pkglib_python_scripts = \
1080         daemons/import-export \
1081         tools/check-cert-expired
1082
1083 nodist_pkglib_python_scripts = \
1084         tools/ensure-dirs \
1085         tools/node-daemon-setup \
1086         tools/prepare-node-join
1087
1088 pkglib_python_basenames = \
1089         $(patsubst daemons/%,%,$(patsubst tools/%,%,\
1090         $(pkglib_python_scripts) $(nodist_pkglib_python_scripts)))
1091
1092 myexeclib_SCRIPTS = \
1093         daemons/daemon-util \
1094         tools/kvm-ifup \
1095         tools/vif-ganeti \
1096         tools/net-common \
1097         $(HS_MYEXECLIB_PROGS)
1098
1099 # compute the basenames of the myexeclib_scripts
1100 myexeclib_scripts_basenames = \
1101         $(patsubst tools/%,%,$(patsubst daemons/%,%,$(patsubst src/%,%,$(myexeclib_SCRIPTS))))
1102
1103 EXTRA_DIST = \
1104         NEWS \
1105         UPGRADE \
1106         epydoc.conf.in \
1107         pylintrc \
1108         pylintrc-test \
1109         autotools/build-bash-completion \
1110         autotools/build-rpc \
1111         autotools/check-header \
1112         autotools/check-imports \
1113         autotools/check-man-dashes \
1114         autotools/check-man-references \
1115         autotools/check-man-warnings \
1116         autotools/check-news \
1117         autotools/check-python-code \
1118         autotools/check-tar \
1119         autotools/check-version \
1120         autotools/docpp \
1121         autotools/gen-py-coverage \
1122         autotools/print-py-constants \
1123         autotools/sphinx-wrapper \
1124         autotools/testrunner \
1125         autotools/wrong-hardcoded-paths \
1126         $(RUN_IN_TEMPDIR) \
1127         daemons/daemon-util.in \
1128         daemons/ganeti-cleaner.in \
1129         $(pkglib_python_scripts) \
1130         devel/upload \
1131         devel/webserver \
1132         tools/kvm-ifup.in \
1133         tools/vif-ganeti.in \
1134         tools/net-common.in \
1135         tools/vcluster-setup.in \
1136         $(docinput) \
1137         doc/html \
1138         $(BUILT_EXAMPLES:%=%.in) \
1139         doc/examples/ganeti.default \
1140         doc/examples/ganeti.default-debug \
1141         doc/examples/hooks/ethers \
1142         doc/examples/gnt-debug/README \
1143         doc/examples/gnt-debug/delay0.json \
1144         doc/examples/gnt-debug/delay50.json \
1145         doc/users/groupmemberships.in \
1146         doc/users/groups.in \
1147         doc/users/users.in \
1148         $(dist_TESTS) \
1149         $(TEST_FILES) \
1150         $(python_test_support) \
1151         man/footer.rst \
1152         $(manrst) \
1153         $(maninput) \
1154         qa/qa-sample.json \
1155         $(qa_scripts) \
1156         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1157         $(HS_PROG_SRCS) \
1158         src/lint-hints.hs \
1159         test/hs/cli-tests-defs.sh \
1160         test/hs/offline-test.sh \
1161         .ghci
1162
1163 man_MANS = \
1164         man/ganeti-cleaner.8 \
1165         man/ganeti-confd.8 \
1166         man/ganeti-luxid.8 \
1167         man/ganeti-listrunner.8 \
1168         man/ganeti-masterd.8 \
1169         man/ganeti-mond.8 \
1170         man/ganeti-noded.8 \
1171         man/ganeti-os-interface.7 \
1172         man/ganeti-extstorage-interface.7 \
1173         man/ganeti-rapi.8 \
1174         man/ganeti-watcher.8 \
1175         man/ganeti.7 \
1176         man/gnt-backup.8 \
1177         man/gnt-cluster.8 \
1178         man/gnt-debug.8 \
1179         man/gnt-group.8 \
1180         man/gnt-network.8 \
1181         man/gnt-instance.8 \
1182         man/gnt-job.8 \
1183         man/gnt-node.8 \
1184         man/gnt-os.8 \
1185         man/gnt-storage.8 \
1186         man/hail.1 \
1187         man/harep.1 \
1188         man/hbal.1 \
1189         man/hcheck.1 \
1190         man/hinfo.1 \
1191         man/hscan.1 \
1192         man/hspace.1 \
1193         man/hroller.1 \
1194         man/htools.1 \
1195         man/mon-collector.7
1196
1197 # Remove extensions from all filenames in man_MANS
1198 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1199
1200 manrst = $(patsubst %,%.rst,$(mannoext))
1201 manhtml = $(patsubst %.rst,%.html,$(manrst))
1202 mangen = $(patsubst %.rst,%.gen,$(manrst))
1203 maninput = \
1204         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1205         $(patsubst %.html,%.html.in,$(manhtml)) \
1206         $(mangen)
1207
1208 manfullpath = $(patsubst man/%.1,man1/%.1,\
1209         $(patsubst man/%.7,man7/%.7,\
1210         $(patsubst man/%.8,man8/%.8,$(man_MANS))))
1211
1212 TEST_FILES = \
1213         test/autotools/autotools-check-news.test \
1214         test/data/htools/clean-nonzero-score.data \
1215         test/data/htools/common-suffix.data \
1216         test/data/htools/empty-cluster.data \
1217         test/data/htools/hail-alloc-drbd.json \
1218         test/data/htools/hail-alloc-invalid-network.json \
1219         test/data/htools/hail-alloc-invalid-twodisks.json \
1220         test/data/htools/hail-alloc-restricted-network.json \
1221         test/data/htools/hail-alloc-spindles.json \
1222         test/data/htools/hail-alloc-twodisks.json \
1223         test/data/htools/hail-change-group.json \
1224         test/data/htools/hail-invalid-reloc.json \
1225         test/data/htools/hail-node-evac.json \
1226         test/data/htools/hail-reloc-drbd.json \
1227         test/data/htools/hbal-dyn.data \
1228         test/data/htools/hbal-excl-tags.data \
1229         test/data/htools/hbal-split-insts.data \
1230         test/data/htools/hspace-tiered-dualspec-exclusive.data \
1231         test/data/htools/hspace-tiered-dualspec.data \
1232         test/data/htools/hspace-tiered-exclusive.data \
1233         test/data/htools/hspace-tiered-ipolicy.data \
1234         test/data/htools/hspace-tiered-mixed.data \
1235         test/data/htools/hspace-tiered-resourcetypes.data \
1236         test/data/htools/hspace-tiered-vcpu.data \
1237         test/data/htools/hspace-tiered.data \
1238         test/data/htools/invalid-node.data \
1239         test/data/htools/missing-resources.data \
1240         test/data/htools/multiple-master.data \
1241         test/data/htools/multiple-tags.data \
1242         test/data/htools/n1-failure.data \
1243         test/data/htools/rapi/groups.json \
1244         test/data/htools/rapi/info.json \
1245         test/data/htools/rapi/instances.json \
1246         test/data/htools/rapi/nodes.json \
1247         test/data/htools/hroller-full.data \
1248         test/data/htools/hroller-nodegroups.data \
1249         test/data/htools/hroller-nonredundant.data \
1250         test/data/htools/hroller-online.data \
1251         test/data/htools/unique-reboot-order.data \
1252         test/hs/shelltests/htools-balancing.test \
1253         test/hs/shelltests/htools-basic.test \
1254         test/hs/shelltests/htools-dynutil.test \
1255         test/hs/shelltests/htools-excl.test \
1256         test/hs/shelltests/htools-hail.test \
1257         test/hs/shelltests/htools-hroller.test \
1258         test/hs/shelltests/htools-hspace.test \
1259         test/hs/shelltests/htools-invalid.test \
1260         test/hs/shelltests/htools-multi-group.test \
1261         test/hs/shelltests/htools-no-backend.test \
1262         test/hs/shelltests/htools-rapi.test \
1263         test/hs/shelltests/htools-single-group.test \
1264         test/hs/shelltests/htools-text-backend.test \
1265         test/hs/shelltests/htools-mon-collector.test \
1266         test/data/bdev-drbd-8.0.txt \
1267         test/data/bdev-drbd-8.3.txt \
1268         test/data/bdev-drbd-8.4.txt \
1269         test/data/bdev-drbd-8.4-no-disk-params.txt \
1270         test/data/bdev-drbd-disk.txt \
1271         test/data/bdev-drbd-net-ip4.txt \
1272         test/data/bdev-drbd-net-ip6.txt \
1273         test/data/bdev-rbd/json_output_empty.txt \
1274         test/data/bdev-rbd/json_output_extra_matches.txt \
1275         test/data/bdev-rbd/json_output_no_matches.txt \
1276         test/data/bdev-rbd/json_output_ok.txt \
1277         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1278         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1279         test/data/bdev-rbd/plain_output_new_ok.txt \
1280         test/data/bdev-rbd/plain_output_old_empty.txt \
1281         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1282         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1283         test/data/bdev-rbd/plain_output_old_ok.txt \
1284         test/data/bdev-rbd/output_invalid.txt \
1285         test/data/cert1.pem \
1286         test/data/cert2.pem \
1287         test/data/cluster_config_2.7.json \
1288         test/data/cluster_config_2.8.json \
1289         test/data/cluster_config_2.9.json \
1290         test/data/instance-minor-pairing.txt \
1291         test/data/instance-prim-sec.txt \
1292         test/data/ip-addr-show-dummy0.txt \
1293         test/data/ip-addr-show-lo-ipv4.txt \
1294         test/data/ip-addr-show-lo-ipv6.txt \
1295         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1296         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1297         test/data/ip-addr-show-lo-oneline.txt \
1298         test/data/ip-addr-show-lo.txt \
1299         test/data/kvm_0.12.5_help.txt \
1300         test/data/kvm_0.15.90_help.txt \
1301         test/data/kvm_0.9.1_help.txt \
1302         test/data/kvm_0.9.1_help_boot_test.txt \
1303         test/data/kvm_1.0_help.txt \
1304         test/data/kvm_1.1.2_help.txt \
1305         test/data/kvm_runtime.json \
1306         test/data/lvs_lv.txt \
1307         test/data/NEWS_OK.txt \
1308         test/data/NEWS_previous_unreleased.txt \
1309         test/data/ovfdata/compr_disk.vmdk.gz \
1310         test/data/ovfdata/config.ini \
1311         test/data/ovfdata/corrupted_resources.ovf \
1312         test/data/ovfdata/empty.ini \
1313         test/data/ovfdata/empty.ovf \
1314         test/data/ovfdata/ganeti.mf \
1315         test/data/ovfdata/ganeti.ovf \
1316         test/data/ovfdata/gzip_disk.ovf \
1317         test/data/ovfdata/new_disk.vmdk \
1318         test/data/ovfdata/no_disk.ini \
1319         test/data/ovfdata/no_disk_in_ref.ovf \
1320         test/data/ovfdata/no_os.ini \
1321         test/data/ovfdata/no_ovf.ova \
1322         test/data/ovfdata/other/rawdisk.raw \
1323         test/data/ovfdata/ova.ova \
1324         test/data/ovfdata/rawdisk.raw \
1325         test/data/ovfdata/second_disk.vmdk \
1326         test/data/ovfdata/unsafe_path.ini \
1327         test/data/ovfdata/virtualbox.ovf \
1328         test/data/ovfdata/wrong_config.ini \
1329         test/data/ovfdata/wrong_extension.ovd \
1330         test/data/ovfdata/wrong_manifest.mf \
1331         test/data/ovfdata/wrong_manifest.ovf \
1332         test/data/ovfdata/wrong_ova.ova \
1333         test/data/ovfdata/wrong_xml.ovf \
1334         test/data/proc_diskstats.txt \
1335         test/data/proc_drbd8.txt \
1336         test/data/proc_drbd80-emptyline.txt \
1337         test/data/proc_drbd80-emptyversion.txt \
1338         test/data/proc_drbd83.txt \
1339         test/data/proc_drbd83_sync.txt \
1340         test/data/proc_drbd83_sync_want.txt \
1341         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1342         test/data/proc_drbd84.txt \
1343         test/data/proc_drbd84_sync.txt \
1344         test/data/proc_meminfo.txt \
1345         test/data/proc_cpuinfo.txt \
1346         test/data/qa-minimal-nodes-instances-only.json \
1347         test/data/sys_drbd_usermode_helper.txt \
1348         test/data/vgreduce-removemissing-2.02.02.txt \
1349         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1350         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1351         test/data/vgs-missing-pvs-2.02.02.txt \
1352         test/data/vgs-missing-pvs-2.02.66.txt \
1353         test/data/xen-xm-info-4.0.1.txt \
1354         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1355         test/data/xen-xm-list-4.0.1-four-instances.txt \
1356         test/data/xen-xm-list-long-4.0.1.txt \
1357         test/data/xen-xm-uptime-4.0.1.txt \
1358         test/py/ganeti-cli.test \
1359         test/py/gnt-cli.test \
1360         test/py/import-export_unittest-helper
1361
1362
1363 python_tests = \
1364         doc/examples/rapi_testutils.py \
1365         test/py/cmdlib/backup_unittest.py \
1366         test/py/cmdlib/cluster_unittest.py \
1367         test/py/cmdlib/cmdlib_unittest.py \
1368         test/py/cmdlib/group_unittest.py \
1369         test/py/cmdlib/instance_unittest.py \
1370         test/py/cmdlib/instance_migration_unittest.py \
1371         test/py/cmdlib/instance_query_unittest.py \
1372         test/py/cmdlib/instance_storage_unittest.py \
1373         test/py/cmdlib/node_unittest.py \
1374         test/py/cmdlib/test_unittest.py \
1375         test/py/cfgupgrade_unittest.py \
1376         test/py/docs_unittest.py \
1377         test/py/ganeti.asyncnotifier_unittest.py \
1378         test/py/ganeti.backend_unittest-runasroot.py \
1379         test/py/ganeti.backend_unittest.py \
1380         test/py/ganeti.bootstrap_unittest.py \
1381         test/py/ganeti.cli_unittest.py \
1382         test/py/ganeti.client.gnt_cluster_unittest.py \
1383         test/py/ganeti.client.gnt_instance_unittest.py \
1384         test/py/ganeti.client.gnt_job_unittest.py \
1385         test/py/ganeti.compat_unittest.py \
1386         test/py/ganeti.confd.client_unittest.py \
1387         test/py/ganeti.config_unittest.py \
1388         test/py/ganeti.constants_unittest.py \
1389         test/py/ganeti.daemon_unittest.py \
1390         test/py/ganeti.errors_unittest.py \
1391         test/py/ganeti.hooks_unittest.py \
1392         test/py/ganeti.ht_unittest.py \
1393         test/py/ganeti.http_unittest.py \
1394         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1395         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1396         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1397         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1398         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1399         test/py/ganeti.hypervisor_unittest.py \
1400         test/py/ganeti.impexpd_unittest.py \
1401         test/py/ganeti.jqueue_unittest.py \
1402         test/py/ganeti.jstore_unittest.py \
1403         test/py/ganeti.locking_unittest.py \
1404         test/py/ganeti.luxi_unittest.py \
1405         test/py/ganeti.masterd.iallocator_unittest.py \
1406         test/py/ganeti.masterd.instance_unittest.py \
1407         test/py/ganeti.mcpu_unittest.py \
1408         test/py/ganeti.netutils_unittest.py \
1409         test/py/ganeti.objects_unittest.py \
1410         test/py/ganeti.opcodes_unittest.py \
1411         test/py/ganeti.outils_unittest.py \
1412         test/py/ganeti.ovf_unittest.py \
1413         test/py/ganeti.qlang_unittest.py \
1414         test/py/ganeti.query_unittest.py \
1415         test/py/ganeti.rapi.baserlib_unittest.py \
1416         test/py/ganeti.rapi.client_unittest.py \
1417         test/py/ganeti.rapi.resources_unittest.py \
1418         test/py/ganeti.rapi.rlib2_unittest.py \
1419         test/py/ganeti.rapi.testutils_unittest.py \
1420         test/py/ganeti.rpc_unittest.py \
1421         test/py/ganeti.runtime_unittest.py \
1422         test/py/ganeti.serializer_unittest.py \
1423         test/py/ganeti.server.rapi_unittest.py \
1424         test/py/ganeti.ssconf_unittest.py \
1425         test/py/ganeti.ssh_unittest.py \
1426         test/py/ganeti.storage.bdev_unittest.py \
1427         test/py/ganeti.storage.container_unittest.py \
1428         test/py/ganeti.storage.drbd_unittest.py \
1429         test/py/ganeti.storage.filestorage_unittest.py \
1430         test/py/ganeti.tools.burnin_unittest.py \
1431         test/py/ganeti.tools.ensure_dirs_unittest.py \
1432         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1433         test/py/ganeti.tools.prepare_node_join_unittest.py \
1434         test/py/ganeti.uidpool_unittest.py \
1435         test/py/ganeti.utils.algo_unittest.py \
1436         test/py/ganeti.utils.filelock_unittest.py \
1437         test/py/ganeti.utils.hash_unittest.py \
1438         test/py/ganeti.utils.io_unittest-runasroot.py \
1439         test/py/ganeti.utils.io_unittest.py \
1440         test/py/ganeti.utils.log_unittest.py \
1441         test/py/ganeti.utils.lvm_unittest.py \
1442         test/py/ganeti.utils.mlock_unittest.py \
1443         test/py/ganeti.utils.nodesetup_unittest.py \
1444         test/py/ganeti.utils.process_unittest.py \
1445         test/py/ganeti.utils.retry_unittest.py \
1446         test/py/ganeti.utils.storage_unittest.py \
1447         test/py/ganeti.utils.text_unittest.py \
1448         test/py/ganeti.utils.version_unittest.py \
1449         test/py/ganeti.utils.wrapper_unittest.py \
1450         test/py/ganeti.utils.x509_unittest.py \
1451         test/py/ganeti.utils_unittest.py \
1452         test/py/ganeti.vcluster_unittest.py \
1453         test/py/ganeti.workerpool_unittest.py \
1454         test/py/pycurl_reset_unittest.py \
1455         test/py/qa.qa_config_unittest.py \
1456         test/py/tempfile_fork_unittest.py
1457
1458 python_test_support = \
1459         test/py/__init__.py \
1460         test/py/lockperf.py \
1461         test/py/testutils.py \
1462         test/py/mocks.py \
1463         test/py/cmdlib/__init__.py \
1464         test/py/cmdlib/testsupport/__init__.py \
1465         test/py/cmdlib/testsupport/cmdlib_testcase.py \
1466         test/py/cmdlib/testsupport/config_mock.py \
1467         test/py/cmdlib/testsupport/iallocator_mock.py \
1468         test/py/cmdlib/testsupport/lock_manager_mock.py \
1469         test/py/cmdlib/testsupport/netutils_mock.py \
1470         test/py/cmdlib/testsupport/processor_mock.py \
1471         test/py/cmdlib/testsupport/rpc_runner_mock.py \
1472         test/py/cmdlib/testsupport/ssh_mock.py \
1473         test/py/cmdlib/testsupport/utils_mock.py \
1474         test/py/cmdlib/testsupport/util.py
1475
1476 haskell_tests = test/hs/htest
1477
1478 dist_TESTS = \
1479         test/py/check-cert-expired_unittest.bash \
1480         test/py/daemon-util_unittest.bash \
1481         test/py/ganeti-cleaner_unittest.bash \
1482         test/py/import-export_unittest.bash \
1483         test/py/cli-test.bash \
1484         test/py/bash_completion.bash
1485
1486 if PY_UNIT
1487 dist_TESTS += $(python_tests)
1488 endif
1489
1490 nodist_TESTS =
1491 check_SCRIPTS =
1492
1493 if WANT_HSTESTS
1494 nodist_TESTS += $(haskell_tests)
1495 dist_TESTS += test/hs/offline-test.sh
1496 check_SCRIPTS += \
1497         test/hs/hpc-htools \
1498         test/hs/hpc-mon-collector \
1499         $(HS_BUILT_TEST_HELPERS)
1500 endif
1501
1502 TESTS = $(dist_TESTS) $(nodist_TESTS)
1503
1504 # Environment for all tests
1505 PLAIN_TESTS_ENVIRONMENT = \
1506         PYTHONPATH=.:./test/py \
1507         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1508         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1509         $(RUN_IN_TEMPDIR)
1510
1511 # Environment for tests run by automake
1512 TESTS_ENVIRONMENT = \
1513         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1514
1515 all_python_code = \
1516         $(dist_sbin_SCRIPTS) \
1517         $(python_scripts) \
1518         $(pkglib_python_scripts) \
1519         $(nodist_pkglib_python_scripts) \
1520         $(nodist_tools_python_scripts) \
1521         $(pkgpython_PYTHON) \
1522         $(client_PYTHON) \
1523         $(cmdlib_PYTHON) \
1524         $(hypervisor_PYTHON) \
1525         $(storage_PYTHON) \
1526         $(rapi_PYTHON) \
1527         $(server_PYTHON) \
1528         $(pytools_PYTHON) \
1529         $(http_PYTHON) \
1530         $(confd_PYTHON) \
1531         $(masterd_PYTHON) \
1532         $(impexpd_PYTHON) \
1533         $(utils_PYTHON) \
1534         $(watcher_PYTHON) \
1535         $(noinst_PYTHON) \
1536         $(qa_scripts)
1537
1538 if PY_UNIT
1539 all_python_code += $(python_tests)
1540 all_python_code += $(python_test_support)
1541 endif
1542
1543 srclink_files = \
1544         man/footer.rst \
1545         test/py/check-cert-expired_unittest.bash \
1546         test/py/daemon-util_unittest.bash \
1547         test/py/ganeti-cleaner_unittest.bash \
1548         test/py/import-export_unittest.bash \
1549         test/py/cli-test.bash \
1550         test/py/bash_completion.bash \
1551         test/hs/offline-test.sh \
1552         test/hs/cli-tests-defs.sh \
1553         $(all_python_code) \
1554         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1555         $(docinput)
1556
1557 check_python_code = \
1558         $(BUILD_BASH_COMPLETION) \
1559         $(CHECK_IMPORTS) \
1560         $(CHECK_HEADER) \
1561         $(DOCPP) \
1562         $(all_python_code)
1563
1564 lint_python_code = \
1565         ganeti \
1566         ganeti/http/server.py \
1567         $(dist_sbin_SCRIPTS) \
1568         $(python_scripts) \
1569         $(pkglib_python_scripts) \
1570         $(BUILD_BASH_COMPLETION) \
1571         $(CHECK_IMPORTS) \
1572         $(CHECK_HEADER) \
1573         $(DOCPP) \
1574         $(gnt_python_sbin_SCRIPTS) \
1575         $(PYTHON_BOOTSTRAP)
1576
1577 standalone_python_modules = \
1578         lib/rapi/client.py \
1579         tools/ganeti-listrunner
1580
1581 pep8_python_code = \
1582         ganeti \
1583         ganeti/http/server.py \
1584         $(dist_sbin_SCRIPTS) \
1585         $(python_scripts) \
1586         $(pkglib_python_scripts) \
1587         $(BUILD_BASH_COMPLETION) \
1588         $(CHECK_HEADER) \
1589         $(DOCPP) \
1590         $(PYTHON_BOOTSTRAP) \
1591         $(gnt_python_sbin_SCRIPTS) \
1592         qa \
1593         $(python_test_support)
1594
1595 test/py/daemon-util_unittest.bash: daemons/daemon-util
1596
1597 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1598
1599 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1600
1601 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1602         sed -f $(REPLACE_VARS_SED) < $< > $@
1603         chmod +x $@
1604
1605 tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
1606         sed -f $(REPLACE_VARS_SED) < $< > $@
1607         chmod +x $@
1608
1609 tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
1610         sed -f $(REPLACE_VARS_SED) < $< > $@
1611         chmod +x $@
1612
1613 tools/users-setup: Makefile $(userspecs)
1614         set -e; \
1615         { echo '#!/bin/sh'; \
1616           echo 'if [ "x$$1" != "x--yes-do-it" ];'; \
1617           echo 'then echo "This will do the following changes"'; \
1618           $(AWK) -- '{print "echo + Will add group ",$$1; count++}\
1619                      END {if (count == 0) {print "echo + No groups to add"}}' doc/users/groups; \
1620           $(AWK) -- '{if (NF > 1) {print "echo + Will add user",$$1,"with primary group",$$2} \
1621                                   else {print "echo + Will add user",$$1}; count++}\
1622                      END {if (count == 0) {print "echo + No users to add"}}' doc/users/users; \
1623           $(AWK) -- '{print "echo + Will add user",$$1,"to group",$$2}' doc/users/groupmemberships; \
1624           echo 'echo'; \
1625           echo 'echo "OK? (y/n)"'; \
1626           echo 'read confirm'; \
1627           echo 'if [ "x$$confirm" != "xy" ]; then exit 0; fi'; \
1628           echo 'fi'; \
1629           $(AWK) -- '{print "addgroup --system",$$1}' doc/users/groups; \
1630           $(AWK) -- '{if (NF > 1) {print "adduser --system --ingroup",$$2,$$1} else {print "adduser --system",$$1}}' doc/users/users; \
1631           $(AWK) -- '{print "adduser",$$1,$$2}' doc/users/groupmemberships; \
1632         } > $@
1633         chmod +x $@
1634
1635 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1636         sed -f $(REPLACE_VARS_SED) < $< > $@
1637         chmod +x $@
1638
1639 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1640         sed -f $(REPLACE_VARS_SED) < $< > $@
1641         chmod +x $@
1642
1643 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1644         sed -f $(REPLACE_VARS_SED) < $< > $@
1645
1646 doc/examples/bash_completion: BC_ARGS = --compact
1647 doc/examples/bash_completion-debug: BC_ARGS =
1648
1649 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1650         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1651         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1652         daemons/ganeti-cleaner \
1653         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1654         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1655           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1656
1657 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1658         lib/build/shell_example_lexer.py \
1659         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1660         @echo "Checking $< for hardcoded paths..."
1661         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1662           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1663           exit 1; \
1664         fi
1665         set -e ; \
1666         trap 'echo auto-removing $@; rm $@' EXIT; \
1667         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1668         $(CHECK_MAN_REFERENCES) $@; \
1669         trap - EXIT
1670
1671 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1672         @test -n "$(PANDOC)" || \
1673           { echo 'pandoc' not found during configure; exit 1; }
1674         set -o pipefail -e; \
1675         trap 'echo auto-removing $@; rm $@' EXIT; \
1676         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1677           sed -e 's/\\@/@/g' > $@; \
1678         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1679         $(CHECK_MAN_DASHES) $@; \
1680         trap - EXIT
1681
1682 man/%.html.in: man/%.gen man/footer.rst
1683         @test -n "$(PANDOC)" || \
1684           { echo 'pandoc' not found during configure; exit 1; }
1685         set -o pipefail ; \
1686         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1687           sed -e 's/\\@/@/g' > $@
1688
1689 man/%: man/%.in  $(REPLACE_VARS_SED)
1690         sed -f $(REPLACE_VARS_SED) < $< > $@
1691
1692 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1693         sed -f $(REPLACE_VARS_SED) < $< > $@
1694
1695 vcs-version:
1696         if test -d .git; then \
1697           git describe > $@; \
1698         elif test ! -f $@ ; then \
1699           echo "Cannot auto-generate $@ file"; exit 1; \
1700         fi
1701
1702 .PHONY: clean-vcs-version
1703 clean-vcs-version:
1704         rm -f vcs-version
1705
1706 .PHONY: regen-vcs-version
1707 regen-vcs-version:
1708         @set -e; \
1709         cd $(srcdir); \
1710         if test -d .git; then \
1711           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1712           git describe > $$T; \
1713           if ! cmp --quiet $$T vcs-version; then \
1714             mv $$T vcs-version; \
1715           fi; \
1716         fi
1717
1718 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1719         vcs-version $(built_base_sources)
1720         set -e; \
1721         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1722         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1723
1724 src/Ganeti/Hs2Py/ListConstants.hs: src/Ganeti/Hs2Py/ListConstants.hs.in \
1725                                    src/Ganeti/Constants.hs \
1726                                  | stamp-directories
1727         @echo Generating $@
1728         @set -e; \
1729 ## Extract constant names from 'Constants.hs' by extracting the left
1730 ## side of all lines containing an equal sign (i.e., '=') and
1731 ## prepending the apostrophe sign (i.e., "'").
1732 ##
1733 ## For example, the constant
1734 ##   adminstDown = ...
1735 ## becomes
1736 ##   'adminstDown
1737         NAMES=$$(sed -e "/^--/ d" $(abs_top_srcdir)/src/Ganeti/Constants.hs |\
1738                  sed -n -e "/=/ s/\(.*\) =.*/    '\1:/g p"); \
1739         m4 -DPY_CONSTANT_NAMES="$$NAMES" $(abs_top_srcdir)/$< > $@
1740
1741 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1742         hsc2hs -o $@ $<
1743
1744 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1745         $(built_base_sources)
1746         set -e; \
1747         { cat $< ; \
1748           echo ; \
1749           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1750             echo "import $$name ()" ; \
1751           done ; \
1752         } > $@
1753
1754 lib/_constants.py: Makefile src/hs2py lib/_constants.py.in | stamp-directories
1755         cat $(abs_top_srcdir)/lib/_constants.py.in > $@
1756         src/hs2py --constants >> $@
1757
1758 lib/constants.py: lib/_constants.py
1759
1760 src/AutoConf.hs: Makefile src/AutoConf.hs.in $(PRINT_PY_CONSTANTS) \
1761                | $(built_base_sources)
1762         @echo "m4 ... >" $@
1763         @m4 -DPACKAGE_VERSION="$(PACKAGE_VERSION)" \
1764             -DVERSION_MAJOR="$(VERSION_MAJOR)" \
1765             -DVERSION_MINOR="$(VERSION_MINOR)" \
1766             -DVERSION_REVISION="$(VERSION_REVISION)" \
1767             -DVERSION_SUFFIX="$(VERSION_SUFFIX)" \
1768             -DVERSION_FULL="$(VERSION_FULL)" \
1769             -DDIRVERSION="$(DIRVERSION)" \
1770             -DLOCALSTATEDIR="$(localstatedir)" \
1771             -DSYSCONFDIR="$(sysconfdir)" \
1772             -DSSH_CONFIG_DIR="$(SSH_CONFIG_DIR)" \
1773             -DSSH_LOGIN_USER="$(SSH_LOGIN_USER)" \
1774             -DSSH_CONSOLE_USER="$(SSH_CONSOLE_USER)" \
1775             -DEXPORT_DIR="$(EXPORT_DIR)" \
1776             -DOS_SEARCH_PATH="\"$(OS_SEARCH_PATH)\"" \
1777             -DES_SEARCH_PATH="\"$(ES_SEARCH_PATH)\"" \
1778             -DXEN_BOOTLOADER="$(XEN_BOOTLOADER)" \
1779             -DXEN_CONFIG_DIR="$(XEN_CONFIG_DIR)" \
1780             -DXEN_KERNEL="$(XEN_KERNEL)" \
1781             -DXEN_INITRD="$(XEN_INITRD)" \
1782             -DKVM_KERNEL="$(KVM_KERNEL)" \
1783             -DSHARED_FILE_STORAGE_DIR="$(SHARED_FILE_STORAGE_DIR)" \
1784             -DIALLOCATOR_SEARCH_PATH="\"$(IALLOCATOR_SEARCH_PATH)\"" \
1785             -DKVM_PATH="$(KVM_PATH)" \
1786             -DIP_PATH="$(IP_PATH)" \
1787             -DSOCAT_PATH="$(SOCAT)" \
1788             -DSOCAT_USE_ESCAPE="$(SOCAT_USE_ESCAPE)" \
1789             -DSOCAT_USE_COMPRESS="$(SOCAT_USE_COMPRESS)" \
1790             -DLVM_STRIPECOUNT="$(LVM_STRIPECOUNT)" \
1791             -DTOOLSDIR="$(libdir)/ganeti/tools" \
1792             -DGNT_SCRIPTS="$(foreach i,$(notdir $(gnt_scripts)),\"$(i)\":)" \
1793             -DHS_HTOOLS_PROGS="$(foreach i,$(HS_HTOOLS_PROGS),\"$(i)\":)" \
1794             -DPKGLIBDIR="$(libdir)/ganeti" \
1795             -DSHAREDIR="$(prefix)/share/ganeti" \
1796             -DVERSIONEDSHAREDIR="$(versionedsharedir)" \
1797             -DDRBD_BARRIERS="$(DRBD_BARRIERS)" \
1798             -DDRBD_NO_META_FLUSH="$(DRBD_NO_META_FLUSH)" \
1799             -DSYSLOG_USAGE="$(SYSLOG_USAGE)" \
1800             -DDAEMONS_GROUP="$(DAEMONS_GROUP)" \
1801             -DADMIN_GROUP="$(ADMIN_GROUP)" \
1802             -DMASTERD_USER="$(MASTERD_USER)" \
1803             -DMASTERD_GROUP="$(MASTERD_GROUP)" \
1804             -DRAPI_USER="$(RAPI_USER)" \
1805             -DRAPI_GROUP="$(RAPI_GROUP)" \
1806             -DCONFD_USER="$(CONFD_USER)" \
1807             -DCONFD_GROUP="$(CONFD_GROUP)" \
1808             -DLUXID_USER="$(LUXID_USER)" \
1809             -DLUXID_GROUP="$(LUXID_GROUP)" \
1810             -DNODED_USER="$(NODED_USER)" \
1811             -DNODED_GROUP="$(NODED_GROUP)" \
1812             -DMOND_USER="$(MOND_USER)" \
1813             -DMOND_GROUP="$(MOND_GROUP)" \
1814             -DDISK_SEPARATOR="$(DISK_SEPARATOR)" \
1815             -DQEMUIMG_PATH="$(QEMUIMG_PATH)" \
1816             -DHTOOLS="True" \
1817             -DENABLE_CONFD="$(ENABLE_CONFD)" \
1818             -DXEN_CMD="$(XEN_CMD)" \
1819             -DENABLE_SPLIT_QUERY="$(ENABLE_SPLIT_QUERY)" \
1820             -DENABLE_RESTRICTED_COMMANDS="$(ENABLE_RESTRICTED_COMMANDS)" \
1821             -DENABLE_MOND="$(ENABLE_MOND)" \
1822             -DHAS_GNU_LN="$(HAS_GNU_LN)" \
1823             -DMAN_PAGES="$$(for i in $(notdir $(man_MANS)); do \
1824                             echo -n "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/("\1",\2):/g'; \
1825                             done)" \
1826             -DAF_INET4="$$(PYTHONPATH=. python $(PRINT_PY_CONSTANTS) AF_INET4)" \
1827             -DAF_INET6="$$(PYTHONPATH=. python $(PRINT_PY_CONSTANTS) AF_INET6)" \
1828         $(abs_top_srcdir)/src/AutoConf.hs.in > $@
1829
1830 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1831         set -e; \
1832         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1833         { echo '# This file is automatically generated, do not edit!'; \
1834           echo '#'; \
1835           echo ''; \
1836           echo '"""Build-time VCS version number for Ganeti.'; \
1837           echo '';\
1838           echo 'This file is autogenerated by the build process.'; \
1839           echo 'For any changes you need to re-run ./configure (and'; \
1840           echo 'not edit by hand).'; \
1841           echo ''; \
1842           echo '"""'; \
1843           echo ''; \
1844           echo '# pylint: disable=C0301,C0324'; \
1845           echo '# because this is autogenerated, we do not want'; \
1846           echo '# style warnings' ; \
1847           echo ''; \
1848           echo "VCS_VERSION = '$$VCSVER'"; \
1849         } > $@
1850
1851 lib/opcodes.py: Makefile src/hs2py lib/opcodes.py.in_before \
1852                 lib/opcodes.py.in_after | stamp-directories
1853         cat $(abs_top_srcdir)/lib/opcodes.py.in_before > $@
1854         src/hs2py --opcodes >> $@
1855         cat $(abs_top_srcdir)/lib/opcodes.py.in_after >> $@
1856
1857 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1858         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1859
1860 $(SHELL_ENV_INIT): Makefile stamp-directories
1861         set -e; \
1862         { echo '# Allow overriding for tests'; \
1863           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1864           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1865           echo; \
1866           echo 'readonly PKGLIBDIR=$(libdir)/ganeti'; \
1867           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1868           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1869           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1870           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1871         } > $@
1872
1873 ## Writes sed script to replace placeholders with build-time values. The
1874 ## additional quotes after the first @ sign are necessary to stop configure
1875 ## from replacing those values as well.
1876 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1877         set -e; \
1878         { echo 's#@''PREFIX@#$(prefix)#g'; \
1879           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1880           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1881           echo 's#@''BINDIR@#$(BINDIR)#g'; \
1882           echo 's#@''SBINDIR@#$(SBINDIR)#g'; \
1883           echo 's#@''LIBDIR@#$(libdir)#g'; \
1884           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1885           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1886           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1887           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1888           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1889           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1890           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1891           echo 's#@''PKGLIBDIR@#$(libdir)/ganeti#g'; \
1892           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1893           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1894           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1895           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1896           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1897           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1898           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1899           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1900           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1901           echo 's#@''GNTNODEDGROUP@#$(NODED_GROUP)#g'; \
1902           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1903           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1904           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1905           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1906           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1907           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1908           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1909           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1910           echo; \
1911           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1912           echo '  r $(SHELL_ENV_INIT)'; \
1913           echo '  d'; \
1914           echo '}'; \
1915         } > $@
1916
1917 # Using deferred evaluation
1918 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1919 daemons/ganeti-watcher: MODULE = ganeti.watcher
1920 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1921 tools/burnin: MODULE = ganeti.tools.burnin
1922 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1923 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1924 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1925 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1926 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1927
1928 $(PYTHON_BOOTSTRAP) $(gnt_scripts) $(gnt_python_sbin_SCRIPTS): Makefile | stamp-directories
1929         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1930         set -e; \
1931         { echo '#!/usr/bin/python'; \
1932           echo '# This file is automatically generated, do not edit!'; \
1933           echo "# Edit $(MODULE) instead."; \
1934           echo; \
1935           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1936           echo; \
1937           echo '# pylint: disable=C0103'; \
1938           echo '# C0103: Invalid name'; \
1939           echo; \
1940           echo 'import sys'; \
1941           echo 'import $(MODULE) as main'; \
1942           echo; \
1943           echo '# Temporarily alias commands until bash completion'; \
1944           echo '# generator is changed'; \
1945           echo 'if hasattr(main, "commands"):'; \
1946           echo '  commands = main.commands # pylint: disable=E1101'; \
1947           echo 'if hasattr(main, "aliases"):'; \
1948           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1949           echo; \
1950           echo 'if __name__ == "__main__":'; \
1951           echo '  sys.exit(main.Main())'; \
1952         } > $@
1953         chmod u+x $@
1954
1955 $(HS_BUILT_TEST_HELPERS): Makefile
1956         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1957         set -e; \
1958         { echo '#!/bin/sh'; \
1959           echo '# This file is automatically generated, do not edit!'; \
1960           echo "# Edit Makefile.am instead."; \
1961           echo; \
1962           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1963         } > $@
1964         chmod u+x $@
1965
1966 stamp-directories: Makefile
1967         $(MAKE) $(AM_MAKEFLAGS) ganeti
1968         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1969         touch $@
1970
1971 # We need to create symlinks because "make distcheck" will not install Python
1972 # files when building.
1973 stamp-srclinks: Makefile | stamp-directories
1974         set -e; \
1975         for i in $(srclink_files); do \
1976           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1977             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1978           fi; \
1979         done
1980         touch $@
1981
1982 .PHONY: ganeti
1983 ganeti:
1984         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1985
1986 .PHONY: check-dirs
1987 check-dirs: $(GENERATED_FILES)
1988         @set -e; \
1989         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1990           error=; \
1991           while read dir; do \
1992             case "$$dir" in \
1993               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1994               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1995             esac; \
1996           done; \
1997           for dir in $(DIRS); do \
1998             if ! test -d "$$dir"; then \
1999               echo "Directory $$dir listed in DIRS does not exist" >&2; \
2000               error=1; \
2001             fi \
2002           done; \
2003           test -z "$$error"; \
2004         }
2005
2006 .PHONY: check-news
2007 check-news:
2008         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
2009
2010 .PHONY: check-local
2011 check-local: check-dirs check-news $(GENERATED_FILES)
2012         $(CHECK_PYTHON_CODE) $(check_python_code)
2013         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
2014         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
2015         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
2016         error= ; \
2017         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
2018           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
2019           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
2020             echo "Incorrect version in README, expected $$expver" >&2; \
2021             error=1; \
2022           fi; \
2023           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
2024               doc/security.rst; do \
2025             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
2026               "Documents Ganeti version $$expver"; then \
2027               echo "Incorrect version in $$file, expected $$expver" >&2; \
2028               error=1; \
2029             fi; \
2030           done; \
2031           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
2032             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
2033             error=1; \
2034           fi; \
2035           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
2036             ".. Last updated for Ganeti $$expver"; then \
2037             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
2038             error=1; \
2039           fi; \
2040         fi; \
2041         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
2042           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
2043             echo "Longest line in $$file is longer than 80 characters" >&2; \
2044             error=1; \
2045           fi; \
2046         done; \
2047         test -z "$$error"
2048
2049 .PHONY: hs-test-%
2050 hs-test-%: test/hs/htest | $(BUILT_PYTHON_SOURCES)
2051         @rm -f htest.tix
2052         test/hs/htest -t $*
2053
2054 .PHONY: hs-tests
2055 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
2056         @rm -f htest.tix
2057         ./test/hs/htest
2058
2059 .PHONY: hs-shell-%
2060 hs-shell-%: test/hs/hpc-htools test/hs/hpc-mon-collector \
2061             $(HS_BUILT_TEST_HELPERS)
2062         @rm -f hpc-htools.tix hpc-mon-collector.tix
2063         HBINARY="./test/hs/hpc-htools" \
2064         SHELLTESTARGS=$(SHELLTESTARGS) \
2065         ./test/hs/offline-test.sh $*
2066
2067 .PHONY: hs-shell
2068 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
2069         @rm -f hpc-htools.tix hpc-mon-collector.tix
2070         HBINARY="./test/hs/hpc-htools" \
2071         SHELLTESTARGS=$(SHELLTESTARGS) \
2072         ./test/hs/offline-test.sh
2073
2074 .PHONY: hs-check
2075 hs-check: hs-tests hs-shell
2076
2077 # E111: indentation is not a multiple of four
2078 # E121: continuation line indentation is not a multiple of four
2079 #       (since our indent level is not 4)
2080 # E125: continuation line does not distinguish itself from next logical line
2081 #       (since our indent level is not 4)
2082 # E123: closing bracket does not match indentation of opening bracket's line
2083 # E127: continuation line over-indented for visual indent
2084 #       (since our indent level is not 4)
2085 # note: do NOT add E128 here; it's a valid style error in most cases!
2086 # I've seen real errors, but also some cases were we indent wrongly
2087 # due to line length; try to rework the cases where it is triggered,
2088 # instead of silencing it
2089 # E261: at least two spaces before inline comment
2090 # E501: line too long (80 characters)
2091 PEP8_IGNORE = E111,E121,E123,E125,E127,E261,E501
2092
2093 # For excluding pep8 expects filenames only, not whole paths
2094 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
2095
2096 LINT_TARGETS = pylint pylint-qa pylint-test
2097 if HAS_PEP8
2098 LINT_TARGETS += pep8
2099 endif
2100 if HAS_HLINT
2101 LINT_TARGETS += hlint
2102 endif
2103
2104 .PHONY: lint
2105 lint: $(LINT_TARGETS)
2106
2107 .PHONY: pylint
2108 pylint: $(GENERATED_FILES)
2109         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
2110         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
2111
2112 .PHONY: pylint-qa
2113 pylint-qa: $(GENERATED_FILES)
2114         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
2115         cd $(top_srcdir)/qa && \
2116           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
2117           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
2118 # FIXME: lint all test code, not just the newly added test support
2119 pylint-test: $(GENERATED_FILES)
2120         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
2121         cd $(top_srcdir) && \
2122                 PYTHONPATH=.:./test/py $(PYLINT) $(LINT_OPTS) \
2123                 --rcfile=pylintrc-test  $(python_test_support)
2124
2125 .PHONY: pep8
2126 pep8: $(GENERATED_FILES)
2127         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
2128         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
2129           --repeat $(pep8_python_code)
2130
2131 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
2132 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
2133 .PHONY: hlint
2134 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
2135         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
2136         @rm -f doc/hs-lint.html
2137         if tty -s; then C="-c"; else C=""; fi; \
2138         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
2139           --ignore "Use first" \
2140           --ignore "Use &&&" \
2141           --ignore "Use void" \
2142           --ignore "Reduce duplication" \
2143           --hint src/lint-hints \
2144           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
2145         @if [ ! -f doc/hs-lint.html ]; then \
2146           echo "All good" > doc/hs-lint.html; \
2147         fi
2148
2149 # a dist hook rule for updating the vcs-version file; this is
2150 # hardcoded due to where it needs to build the file...
2151 dist-hook:
2152         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
2153         rm -f $(top_distdir)/vcs-version
2154         cp -p $(srcdir)/vcs-version $(top_distdir)
2155
2156 # a distcheck hook rule for catching revision control directories
2157 distcheck-hook:
2158         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
2159           echo "Found revision control files in final archive." 1>&2; \
2160           exit 1; \
2161         fi
2162         if find $(top_distdir) -name '*.py[co]' | grep .; then \
2163           echo "Found Python byte code in final archive." 1>&2; \
2164           exit 1; \
2165         fi
2166         if find $(top_distdir) -name '*~' | grep .; then \
2167           echo "Found backup files in final archive." 1>&2; \
2168           exit 1; \
2169         fi
2170 # Empty files or directories should not be distributed. They can cause
2171 # unnecessary warnings for packagers. Directories used by automake during
2172 # distcheck must be excluded.
2173         if find $(top_distdir) -empty -and -not \( \
2174             -path $(top_distdir)/_build -or \
2175             -path $(top_distdir)/_inst \) | grep .; then \
2176           echo "Found empty files or directories in final archive." 1>&2; \
2177           exit 1; \
2178         fi
2179         if test -e $(top_distdir)/doc/man-html; then \
2180           echo "Found documentation including man pages in final archive" >&2; \
2181           exit 1; \
2182         fi
2183
2184 # Backwards compatible distcheck-release target
2185 distcheck-release: distcheck
2186
2187 distrebuildcheck: dist
2188         set -e; \
2189         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
2190         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
2191         cd $$builddir; \
2192         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
2193         cd $(distdir); \
2194         ./configure; \
2195         $(MAKE) maintainer-clean; \
2196         cp $(abs_srcdir)/vcs-version .; \
2197         ./configure; \
2198         $(MAKE) $(AM_MAKEFLAGS)
2199
2200 dist-release: dist
2201         set -e; \
2202         for i in $(DIST_ARCHIVES); do \
2203           echo -n "Checking $$i ... "; \
2204           autotools/check-tar < $$i; \
2205           echo OK; \
2206         done
2207
2208 install-exec-local:
2209         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
2210           "$(DESTDIR)${localstatedir}/log/ganeti" \
2211           "$(DESTDIR)${localstatedir}/run/ganeti"
2212         for dir in $(SYMLINK_TARGET_DIRS); do \
2213           @mkdir_p@  $(DESTDIR)$$dir; \
2214         done
2215         $(LN_S) -f $(sysconfdir)/ganeti/lib $(DESTDIR)$(defaultversiondir)
2216         $(LN_S) -f $(sysconfdir)/ganeti/share $(DESTDIR)$(defaultversionedsharedir)
2217         for prog in $(HS_BIN_ROLES); do \
2218           $(LN_S) -f $(defaultversiondir)$(BINDIR)/$$prog $(DESTDIR)$(BINDIR)/$$prog; \
2219         done
2220         $(LN_S) -f $(defaultversiondir)$(libdir)/ganeti/iallocators/hail $(DESTDIR)$(libdir)/ganeti/iallocators/hail
2221         for prog in $(all_sbin_scripts); do \
2222           $(LN_S) -f $(defaultversiondir)$(SBINDIR)/$$prog $(DESTDIR)$(SBINDIR)/$$prog; \
2223         done
2224         for prog in $(gnt_scripts_basenames); do \
2225           $(LN_S) -f $(defaultversionedsharedir)/$$prog $(DESTDIR)$(SBINDIR)/$$prog; \
2226         done
2227         for prog in $(pkglib_python_basenames); do \
2228           $(LN_S) -f $(defaultversionedsharedir)/$$prog $(DESTDIR)$(libdir)/ganeti/$$prog; \
2229         done
2230         for prog in $(tools_python_basenames); do \
2231           $(LN_S) -f $(defaultversionedsharedir)/$$prog $(DESTDIR)$(libdir)/ganeti/tools/$$prog; \
2232         done
2233         for prog in $(tools_basenames); do \
2234           $(LN_S) -f $(defaultversiondir)/$(libdir)/ganeti/tools/$$prog $(DESTDIR)$(libdir)/ganeti/tools/$$prog; \
2235         done
2236         if ! test -n '$(ENABLE_MANPAGES)'; then \
2237           for man in $(manfullpath); do \
2238             $(LN_S) -f $(defaultversionedsharedir)/root$(MANDIR)/$$man $(DESTDIR)$(MANDIR)/$$man; \
2239           done; \
2240         fi
2241         for prog in $(myexeclib_scripts_basenames); do \
2242           $(LN_S) -f $(defaultversiondir)$(libdir)/ganeti/$$prog $(DESTDIR)$(libdir)/ganeti/$$prog; \
2243         done
2244 if INSTALL_SYMLINKS
2245         $(LN_S) -f $(versionedsharedir) $(DESTDIR)$(sysconfdir)/ganeti/share
2246         $(LN_S) -f $(versiondir) $(DESTDIR)$(sysconfdir)/ganeti/lib
2247 endif
2248
2249 .PHONY: apidoc
2250 if WANT_HSAPIDOC
2251 apidoc: py-apidoc hs-apidoc
2252 else
2253 apidoc: py-apidoc
2254 endif
2255
2256 .PHONY: py-apidoc
2257 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
2258         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
2259         $(RUN_IN_TEMPDIR) epydoc -v \
2260           --conf $(CURDIR)/epydoc.conf \
2261           --output $(CURDIR)/$(APIDOC_PY_DIR)
2262
2263 .PHONY: hs-apidoc
2264 hs-apidoc: $(APIDOC_HS_DIR)/index.html
2265
2266 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
2267         @test -n "$(HSCOLOUR)" || \
2268             { echo 'HsColour' not found during configure; exit 1; }
2269         @test -n "$(HADDOCK)" || \
2270             { echo 'haddock' not found during configure; exit 1; }
2271         rm -rf $(APIDOC_HS_DIR)/*
2272         for i in $(ALL_APIDOC_HS_DIRS); do \
2273           @mkdir_p@ $$i; \
2274           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
2275         done
2276         set -e ; \
2277         export LC_ALL=en_US.UTF-8; \
2278         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
2279         if [ "$(HS_PARALLEL3)" ]; \
2280         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
2281         fi; \
2282         if [ "$(HS_REGEX_PCRE)" ]; \
2283         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
2284         fi; \
2285         for file in $(HS_LIBTESTBUILT_SRCS); do \
2286           f_nosrc=$${file##src/}; \
2287           f_notst=$${f_nosrc##test/hs/}; \
2288           f_html=$${f_notst%%.hs}.html; \
2289           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2290         done ; \
2291         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2292           -t ganeti -p src/haddock-prologue \
2293           --source-module="%{MODULE/.//}.html" \
2294           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2295           $$OPTGHC \
2296           $(HS_LIBTESTBUILT_SRCS)
2297
2298 .PHONY: TAGS
2299 TAGS: $(GENERATED_FILES)
2300         rm -f TAGS
2301         $(GHC) -e ":etags" -v0 \
2302           $(filter-out -O -Werror,$(HFLAGS)) \
2303           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2304           $(HS_LIBTEST_SRCS)
2305         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2306           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2307           -path './qa/*.py' | \
2308           etags -l python -a -
2309
2310 .PHONY: coverage
2311
2312 COVERAGE_TESTS=
2313 if WANT_HTOOLS
2314 COVERAGE_TESTS += hs-coverage
2315 endif
2316 if PY_UNIT
2317 COVERAGE_TESTS += py-coverage
2318 endif
2319
2320 coverage: $(COVERAGE_TESTS)
2321
2322 .PHONY: py-coverage
2323 py-coverage: $(GENERATED_FILES) $(python_tests)
2324         @test -n "$(PYCOVERAGE)" || \
2325             { echo 'python-coverage' not found during configure; exit 1; }
2326         set -e; \
2327         COVERAGE=$(PYCOVERAGE) \
2328         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2329         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2330         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2331         $(PLAIN_TESTS_ENVIRONMENT) \
2332         $(abs_top_srcdir)/autotools/gen-py-coverage \
2333         $(python_tests)
2334
2335 .PHONY: hs-coverage
2336 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2337         rm -f *.tix
2338         $(MAKE) $(AM_MAKEFLAGS) hs-check
2339         @mkdir_p@ $(COVERAGE_HS_DIR)
2340         hpc sum --union $(HPCEXCL) \
2341           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2342         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2343         hpc report coverage-hs.tix | tee $(COVERAGE_HS_DIR)/report.txt
2344         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2345
2346 # Special "kind-of-QA" target for htools, needs special setup (all
2347 # tools compiled with -fhpc)
2348 .PHONY: live-test
2349 live-test: all
2350         set -e ; \
2351         cd src; \
2352         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2353         rm -f *.tix *.mix; \
2354         ./live-test.sh; \
2355         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2356           --output=live-test.tix ; \
2357         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2358         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2359           --srcdir=.. $(HPCEXCL) ; \
2360         hpc report --srcdir=.. live-test $(HPCEXCL)
2361
2362 commit-check: autotools-check distcheck lint apidoc
2363
2364 autotools-check:
2365         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2366   $(abs_top_srcdir)/test/autotools/*-*.test \
2367   -- --hide-successes
2368
2369 .PHONY: gitignore-check
2370 gitignore-check:
2371         @if [ -n "`git status --short`" ]; then \
2372           echo "Git status is not clean!" 1>&2 ; \
2373           git status --short; \
2374           exit 1; \
2375         fi
2376
2377 # target to rebuild all man pages (both groff and html output)
2378 .PHONY: man
2379 man: $(man_MANS) $(manhtml)
2380
2381 # Target that builds all binaries (including those that are not
2382 # rebuilt except when running the tests)
2383 .PHONY: really-all
2384 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2385
2386 # we don't need the ancient implicit rules:
2387 %: %,v
2388 %: RCS/%,v
2389 %: RCS/%
2390 %: s.%
2391 %: SCCS/s.%
2392
2393 -include ./Makefile.local
2394
2395 # vim: set noet :